function [nSIGNAL,nFreqs,xSIGNAL,xFreqs] = upsignal(signal,...
                                                    frequency,...
                                                    filter,...
                                                    generator,...
                                                    n)

if ischar(signal) == 1
[xSIGNAL,xFreqs] = audioread(signal);
nFreqs = n*frequency;
else
    xSIGNAL = signal;
    xFreqs = frequency;
    nFreqs = n*frequency;
end
 %Criando o valor de frequencia n-vezes aumentada.

t = 1:1/n:size(xSIGNAL);

fSIGNAL = zeros(size(xSIGNAL));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%FILTROS Finite Impulse Response%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if strcmp(filter,'fir_dalai1')==1
    q0 = 49/40;
    q1 = -11/90;
    q2 = 7/720;
    if size(xSIGNAL,2) == 2
        fSIGNAL(1,1) = q0*xSIGNAL(1,1) + 2*q1*xSIGNAL(2,1) ...
            + 2*q2*xSIGNAL(3,1);
        fSIGNAL(1,2) = q0*xSIGNAL(1,2) + 2*q1*xSIGNAL(2,2) ...
            + 2*q2*xSIGNAL(3,2);
        fSIGNAL(2,1) = q1*xSIGNAL(1,1) + q0*xSIGNAL(2,1) ...
            + q1*xSIGNAL(3,1) + 2*q2*xSIGNAL(4,1);
        fSIGNAL(2,2) = q1*xSIGNAL(1,2) + q0*xSIGNAL(2,2) ...
            + q1*xSIGNAL(3,2) + 2*q2*xSIGNAL(4,2);
        fSIGNAL(size(xSIGNAL,1)-1,1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1) ...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,1) ...
            + q1*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-1,2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2) ...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,2) ...
            + q1*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1),1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1),2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i,1) = q2*xSIGNAL(i-2,1) + q1*xSIGNAL(i-1,1)...
                + q0*xSIGNAL(i,1) + q1*xSIGNAL(i+1,1) + q2*xSIGNAL(i+2,1);
            fSIGNAL(i,2) = q2*xSIGNAL(i-2,2) + q1*xSIGNAL(i-1,2)...
                + q0*xSIGNAL(i,2) + q1*xSIGNAL(i+1,2) + q2*xSIGNAL(i+2,2);
        end
    else
        fSIGNAL(1) = q0*xSIGNAL(1) + 2*q1*xSIGNAL(2) + 2*q2*xSIGNAL(3);
        fSIGNAL(2) = q1*xSIGNAL(1) + q0*xSIGNAL(2) + q1*xSIGNAL(3)...
            + 2*q2*xSIGNAL(4);
        fSIGNAL(size(xSIGNAL,1)-1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1)...
            + q1*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q0*xSIGNAL(size(xSIGNAL,1));
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i,1) = q2*xSIGNAL(i-2,1)...
                + q1*xSIGNAL(i-1) + q0*xSIGNAL(i)...
                + q1*xSIGNAL(i+1) + q2*xSIGNAL(i+2);
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
elseif strcmp(filter,'fir_dalai2')==1
    q0 = 437/320;
    q1 = -97/480;
    q2 = 37/1920;
    if size(xSIGNAL,2) == 2
        fSIGNAL(1,1) = q0*xSIGNAL(1,1) + 2*q1*xSIGNAL(2,1)...
            + 2*q2*xSIGNAL(3,1);
        fSIGNAL(1,2) = q0*xSIGNAL(1,2) + 2*q1*xSIGNAL(2,2)...
            + 2*q2*xSIGNAL(3,2);
        fSIGNAL(2,1) = q1*xSIGNAL(1,1) + q0*xSIGNAL(2,1)...
            + q1*xSIGNAL(3,1) + 2*q2*xSIGNAL(4,1);
        fSIGNAL(2,2) = q1*xSIGNAL(1,2) + q0*xSIGNAL(2,2)...
            + q1*xSIGNAL(3,2) + 2*q2*xSIGNAL(4,2);
        fSIGNAL(size(xSIGNAL,1)-1,1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q1*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-1,2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q1*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1),1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1),2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i,1) = q2*xSIGNAL(i-2,1) + q1*xSIGNAL(i-1,1)...
                + q0*xSIGNAL(i,1) + q1*xSIGNAL(i+1,1) + q2*xSIGNAL(i+2,1);
            fSIGNAL(i,2) = q2*xSIGNAL(i-2,2) + q1*xSIGNAL(i-1,2)...
                + q0*xSIGNAL(i,2) + q1*xSIGNAL(i+1,2) + q2*xSIGNAL(i+2,2);
        end
    else
        fSIGNAL(1) = q0*xSIGNAL(1) + 2*q1*xSIGNAL(2) + 2*q2*xSIGNAL(3);
        fSIGNAL(2) = q1*xSIGNAL(1) + q0*xSIGNAL(2) + q1*xSIGNAL(3)...
            + 2*q2*xSIGNAL(4);
        fSIGNAL(size(xSIGNAL,1)-1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1) + q1*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q0*xSIGNAL(size(xSIGNAL,1));
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i) = q2*xSIGNAL(i-2) + q1*xSIGNAL(i-1)...
                + q0*xSIGNAL(i) + q1*xSIGNAL(i+1) + q2*xSIGNAL(i+2);
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'fir_dalai3')==1
    q0 = 12223/7560;
    q1 = -919/2520;
    q2 = 311/5040;
    q3 = -41/7560;
    if size(xSIGNAL,2) == 2
        fSIGNAL(1,1) = q0*xSIGNAL(1,1) + 2*q1*xSIGNAL(2,1)...
            + 2*q2*xSIGNAL(3,1) + 2*q3*xSIGNAL(4,1);
        fSIGNAL(1,2) = q0*xSIGNAL(1,2) + 2*q1*xSIGNAL(2,2)...
            + 2*q2*xSIGNAL(3,2) + 2*q3*xSIGNAL(4,2);
        fSIGNAL(2,1) = q1*xSIGNAL(1,1) + q0*xSIGNAL(2,1)...
            + q1*xSIGNAL(3,1) + 2*q2*xSIGNAL(4,1) + 2*q3*xSIGNAL(5,1);
        fSIGNAL(2,2) = q1*xSIGNAL(1,2) + q0*xSIGNAL(2,2)...
            + q1*xSIGNAL(3,2) + 2*q2*xSIGNAL(4,2) + 2*q3*xSIGNAL(5,2);
        fSIGNAL(3,1) = q2*xSIGNAL(1,1) + q1*xSIGNAL(2,1)...
            + q0*xSIGNAL(3,1) + q1*xSIGNAL(4,1)...
            + q2*xSIGNAL(5,1) + 2*q3*xSIGNAL(6,1);
        fSIGNAL(3,2) = q2*xSIGNAL(1,2) + q1*xSIGNAL(2,2)...
            + q0*xSIGNAL(3,2) + q1*xSIGNAL(4,2)...
            + q2*xSIGNAL(5,2) + 2*q3*xSIGNAL(6,2);
        fSIGNAL(size(xSIGNAL,1)-2,1) = 2*q3*xSIGNAL(size(xSIGNAL,1)-5,1)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q2*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-2,2) = 2*q3*xSIGNAL(size(xSIGNAL,1)-5,2)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q2*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1)-1,1) = 2*q3*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q1*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-1,2) = 2*q3*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q1*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1),1) = 2*q3*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1),2) = 2*q3*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q0*xSIGNAL(size(xSIGNAL,1),2);
        for i = 4:(size(fSIGNAL)-3)
            fSIGNAL(i,1) = q3*xSIGNAL(i-3,1) + q2*xSIGNAL(i-2,1)...
                + q1*xSIGNAL(i-1,1) + q0*xSIGNAL(i,1)...
                + q1*xSIGNAL(i+1,1) + q2*xSIGNAL(i+2,1)...
                + q3*xSIGNAL(i+3,1);
            fSIGNAL(i,2) = q3*xSIGNAL(i-3,2) + q2*xSIGNAL(i-2,2)...
                + q1*xSIGNAL(i-1,2) + q0*xSIGNAL(i,2)...
                + q1*xSIGNAL(i+1,2) + q2*xSIGNAL(i+2,2)...
                + q3*xSIGNAL(i+3,2);
        end
    else
        fSIGNAL(1) = q0*xSIGNAL(1) + 2*q1*xSIGNAL(2) + 2*q2*xSIGNAL(3)...
            + 2*q3*xSIGNAL(4);
        fSIGNAL(2) = q1*xSIGNAL(1) + q0*xSIGNAL(2) + q1*xSIGNAL(3)...
            + 2*q2*xSIGNAL(4) + 2*q3*xSIGNAL(5);
        fSIGNAL(3) = q2*xSIGNAL(1) + q1*xSIGNAL(2) + q0*xSIGNAL(3)...
            + q1*xSIGNAL(4) + q2*xSIGNAL(5) + 2*q3*xSIGNAL(6);
        fSIGNAL(size(xSIGNAL,1)-2) = 2*q3*xSIGNAL(size(xSIGNAL,1)-5)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q2*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)-1) = 2*q3*xSIGNAL(size(xSIGNAL,1)-4)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1)...
            + q1*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)) = 2*q3*xSIGNAL(size(xSIGNAL,1)-3)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q0*xSIGNAL(size(xSIGNAL,1));
        for i = 4:(size(fSIGNAL)-3)
            fSIGNAL(i) = q3*xSIGNAL(i-3) + q2*xSIGNAL(i-2)...
                + q1*xSIGNAL(i-1) + q0*xSIGNAL(i) + q1*xSIGNAL(i+1)...
                + q2*xSIGNAL(i+2) + q3*xSIGNAL(i+3);
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'fir_blu35')==1
    q0 = 8.76565;
    q1 = 4.65992;
    q2 = 0.621773;
    q3 = 0.012285;
    q4 = 1.875*10^(-6);
    if size(xSIGNAL,2) == 2
        fSIGNAL(1,1) = q0*xSIGNAL(1,1) + 2*q1*xSIGNAL(2,1)...
            + 2*q2*xSIGNAL(3,1) + 2*q3*xSIGNAL(4,1) + 2*q4*xSIGNAL(5,1);
        fSIGNAL(1,2) = q0*xSIGNAL(1,2) + 2*q1*xSIGNAL(2,2)...
            + 2*q2*xSIGNAL(3,2) + 2*q3*xSIGNAL(4,2) + 2*q4*xSIGNAL(5,2);
        fSIGNAL(2,1) = q1*xSIGNAL(1,1) + q0*xSIGNAL(2,1)...
            + q1*xSIGNAL(3,1) + 2*q2*xSIGNAL(4,1) + 2*q3*xSIGNAL(5,1)...
            + 2*q4*xSIGNAL(6,1);
        fSIGNAL(2,2) = q1*xSIGNAL(1,2) + q0*xSIGNAL(2,2)...
            + q1*xSIGNAL(3,2) + 2*q2*xSIGNAL(4,2)...
            + 2*q3*xSIGNAL(5,2) + 2*q4*xSIGNAL(6,2);
        fSIGNAL(3,1) = q2*xSIGNAL(1,1) + q1*xSIGNAL(2,1)...
            + q0*xSIGNAL(3,1) + q1*xSIGNAL(4,1) + q2*xSIGNAL(5,1)...
            + 2*q3*xSIGNAL(6,1) + 2*q4*xSIGNAL(7,1);
        fSIGNAL(3,2) = q2*xSIGNAL(1,2) + q1*xSIGNAL(2,2)...
            + q0*xSIGNAL(3,2) + q1*xSIGNAL(4,2) + q2*xSIGNAL(5,2)...
            + 2*q3*xSIGNAL(6,2) + 2*q4*xSIGNAL(7,2);
        fSIGNAL(4,1) = q3*xSIGNAL(1,1) + q2*xSIGNAL(2,1)...
            + q1*xSIGNAL(3,1) + q0*xSIGNAL(4,1) + q1*xSIGNAL(5,1)...
            + q2*xSIGNAL(6,1) + q3*xSIGNAL(7,1) + 2*q4*xSIGNAL(8,1);
        fSIGNAL(4,2) = q3*xSIGNAL(1,2) + q2*xSIGNAL(2,2)...
            + q1*xSIGNAL(3,2) + q0*xSIGNAL(4,2) + q1*xSIGNAL(5,2)...
            + q2*xSIGNAL(6,2) + q3*xSIGNAL(7,2) + 2*q4*xSIGNAL(8,2);
        fSIGNAL(size(xSIGNAL,1)-3,1) = 2*q4*xSIGNAL(size(xSIGNAL,1)-7,1)...
            + q3*xSIGNAL(size(xSIGNAL,1)-6,1)...
            + q2*xSIGNAL(size(xSIGNAL,1)-5,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q2*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q3*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-3,2) = 2*q4*xSIGNAL(size(xSIGNAL,1)-7,2)...
            + q3*xSIGNAL(size(xSIGNAL,1)-6,2)...
            + q2*xSIGNAL(size(xSIGNAL,1)-5,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q2*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q3*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1)-2,1) = 2*q4*xSIGNAL(size(xSIGNAL,1)-6,1)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-5,1)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q2*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-2,2) = 2*q4*xSIGNAL(size(xSIGNAL,1)-6,2)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-5,2)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q2*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1)-1,1) = 2*q4*xSIGNAL(size(xSIGNAL,1)-5,1)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q1*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-1,2) = 2*q4*xSIGNAL(size(xSIGNAL,1)-5,2)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q1*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1),1) = 2*q4*xSIGNAL(size(xSIGNAL,1)-4,1)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1),2) = 2*q4*xSIGNAL(size(xSIGNAL,1)-4,2)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q0*xSIGNAL(size(xSIGNAL,1),2);
        for i = 5:(size(xSIGNAL)-4)
            fSIGNAL(i,1) = q4*xSIGNAL(i-4,1) + q3*xSIGNAL(i-3,1)...
                + q2*xSIGNAL(i-2,1) + q1*xSIGNAL(i-1,1)...
                + q0*xSIGNAL(i,1) + q1*xSIGNAL(i+1,1)...
                + q2*xSIGNAL(i+2,1) + q3*xSIGNAL(i+3,1)...
                + q4*xSIGNAL(i+4,1);
            fSIGNAL(i,2) = q4*xSIGNAL(i-4,2) + q3*xSIGNAL(i-3,2)...
                + q2*xSIGNAL(i-2,2) + q1*xSIGNAL(i-1,2)...
                + q0*xSIGNAL(i,2) + q1*xSIGNAL(i+1,2)...
                + q2*xSIGNAL(i+2,2) + q3*xSIGNAL(i+3,2)...
                + q4*xSIGNAL(i+4,2);
        end
    else
        fSIGNAL(1) = q0*xSIGNAL(1) + 2*q1*xSIGNAL(2) + 2*q2*xSIGNAL(3)...
            + 2*q3*xSIGNAL(4) + 2*q4*xSIGNAL(5);
        fSIGNAL(2) = q1*xSIGNAL(1) + q0*xSIGNAL(2) + q1*xSIGNAL(3)...
            + 2*q2*xSIGNAL(4) + 2*q3*xSIGNAL(5) + 2*q4*xSIGNAL(6);
        fSIGNAL(3) = q2*xSIGNAL(1) + q1*xSIGNAL(2) + q0*xSIGNAL(3)...
            + q1*xSIGNAL(4) + q2*xSIGNAL(5)...
            + 2*q3*xSIGNAL(6) + 2*q4*xSIGNAL(7);
        fSIGNAL(4) = q3*xSIGNAL(1) + q2*xSIGNAL(2) + q1*xSIGNAL(3)...
            + q0*xSIGNAL(4) + q1*xSIGNAL(5) + q2*xSIGNAL(6)...
            + q3*xSIGNAL(7) + 2*q4*xSIGNAL(8);
        fSIGNAL(size(xSIGNAL,1)-3) = 2*q4*xSIGNAL(size(xSIGNAL,1)-7)...
            + q3*xSIGNAL(size(xSIGNAL,1)-6)...
            + q2*xSIGNAL(size(xSIGNAL,1)-5)...
            + q1*xSIGNAL(size(xSIGNAL,1)-4)...
            + q0*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q2*xSIGNAL(size(xSIGNAL,1)-1)...
            + q3*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)-2) = 2*q4*xSIGNAL(size(xSIGNAL,1)-6)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-5)...
            + q2*xSIGNAL(size(xSIGNAL,1)-4)...
            + q1*xSIGNAL(size(xSIGNAL,1)-3)...
            + q0*xSIGNAL(size(xSIGNAL,1)-2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q2*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)-1) = 2*q4*xSIGNAL(size(xSIGNAL,1)-5)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-4)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1)...
            + q1*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)) = 2*q4*xSIGNAL(size(xSIGNAL,1)-4)...
            + 2*q3*xSIGNAL(size(xSIGNAL,1)-3)...
            + 2*q2*xSIGNAL(size(xSIGNAL,1)-2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q0*xSIGNAL(size(xSIGNAL,1));
        for i = 5:(size(xSIGNAL)-4)
            fSIGNAL(i) = q4*xSIGNAL(i-4) + q3*xSIGNAL(i-3)...
                + q2*xSIGNAL(i-2) + q1*xSIGNAL(i-1)...
                + q0*xSIGNAL(i) + q1*xSIGNAL(i+1)...
                + q2*xSIGNAL(i+2) + q3*xSIGNAL(i+3) + q4*xSIGNAL(i+4);
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'mcool')==1
    q0 = 1/2;
    q1 = 2/9;
    q2 = 1/36;
    if size(xSIGNAL,2) == 2
        fSIGNAL(1,1) = q0*xSIGNAL(1,1) + 2*q1*xSIGNAL(2,1)...
            + 2*q2*xSIGNAL(3,1);
        fSIGNAL(1,2) = q0*xSIGNAL(1,2) + 2*q1*xSIGNAL(2,2)...
            + 2*q2*xSIGNAL(3,2);
        fSIGNAL(2,1) = q1*xSIGNAL(1,1) + q0*xSIGNAL(2,1)...
            + q1*xSIGNAL(3,1) + 2*q2*xSIGNAL(4,1);
        fSIGNAL(2,2) = q1*xSIGNAL(1,2) + q0*xSIGNAL(2,2)...
            + q1*xSIGNAL(3,2) + 2*q2*xSIGNAL(4,2);
        fSIGNAL(size(xSIGNAL,1)-1,1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,1)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q1*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1)-1,2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3,2)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q1*xSIGNAL(size(xSIGNAL,1),2);
        fSIGNAL(size(xSIGNAL,1),1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,1)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,1)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        fSIGNAL(size(xSIGNAL,1),2) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2,2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1,2)...
            + q0*xSIGNAL(size(xSIGNAL,1),1);
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i,1) = q2*xSIGNAL(i-2,1) + q1*xSIGNAL(i-1,1)...
                + q0*xSIGNAL(i,1) + q1*xSIGNAL(i+1,1) + q2*xSIGNAL(i+2,1);
            fSIGNAL(i,2) = q2*xSIGNAL(i-2,2) + q1*xSIGNAL(i-1,2)...
                + q0*xSIGNAL(i,2) + q1*xSIGNAL(i+1,2) + q2*xSIGNAL(i+2,2);
        end
    else
        fSIGNAL(1) = q0*xSIGNAL(1) + 2*q1*xSIGNAL(2) + 2*q2*xSIGNAL(3);
        fSIGNAL(2) = q1*xSIGNAL(1) + q0*xSIGNAL(2) + q1*xSIGNAL(3)...
            + 2*q2*xSIGNAL(4);
        fSIGNAL(size(xSIGNAL,1)-1) = 2*q2*xSIGNAL(size(xSIGNAL,1)-3)...
            + q1*xSIGNAL(size(xSIGNAL,1)-2)...
            + q0*xSIGNAL(size(xSIGNAL,1)-1) + q1*xSIGNAL(size(xSIGNAL,1));
        fSIGNAL(size(xSIGNAL,1)) = 2*q2*xSIGNAL(size(xSIGNAL,1)-2)...
            + 2*q1*xSIGNAL(size(xSIGNAL,1)-1)...
            + q0*xSIGNAL(size(xSIGNAL,1));
        for i = 3:(size(fSIGNAL)-2)
            fSIGNAL(i,1) = q2*xSIGNAL(i-2,1) + q1*xSIGNAL(i-1)...
                + q0*xSIGNAL(i) + q1*xSIGNAL(i+1) + q2*xSIGNAL(i+2);
        end
    end
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%FILTROS Infinite Impulse Response%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

elseif strcmp(filter,'ifir_condat0')==1
    %VALORES DO FILTRO%
    q0 = 13/12;
    q1 = -1/24;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_condat1')==1
    %VALORES DO FILTRO%
    q0 = 5/6;
    q1 = 1/12;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_condat2')==1
    %VALORES DO FILTRO%
    q0 = 233/320;
    q1 = 67/480;
    q2 = -7/1920;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_condat3')==1
    %VALORES DO FILTRO%
    q0 = 79/120;
    q1 = 31/180;
    q2 = -1/720;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_condat_omoms3')==1
    %VALORES DO FILTRO%
    q0 = 523/840;
    q1 = 79/420;
    q2 = 1/1680;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_blu35')==1
    %VALORES DO FILTRO%
    q0 = 7.36952;
    q1 = 4.67858;
    q2 = 1.20608;
    q3 = 0.10541;
    q4 = 0.00196;
    q5 = 0.00001;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
    mq3 = q3*ones(length(xSIGNAL)-3,1);
    mq4 = q4*ones(length(xSIGNAL)-4,1);
    mq5 = q5*ones(length(xSIGNAL)-5,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q6 = sparse(1:(length(xSIGNAL)-3),4:length(xSIGNAL),mq3,...
        length(xSIGNAL),length(xSIGNAL));
    Q7 = sparse(4:length(xSIGNAL),1:(length(xSIGNAL)-3),mq3,...
        length(xSIGNAL),length(xSIGNAL));
    Q8 = sparse(1:(length(xSIGNAL)-4),5:length(xSIGNAL),mq4,...
        length(xSIGNAL),length(xSIGNAL));
    Q9 = sparse(5:length(xSIGNAL),1:(length(xSIGNAL)-4),mq4,...
        length(xSIGNAL),length(xSIGNAL));
    Q10 = sparse(1:(length(xSIGNAL)-5),6:length(xSIGNAL),mq5,...
        length(xSIGNAL),length(xSIGNAL));
    Q11 = sparse(6:length(xSIGNAL),1:(length(xSIGNAL)-5),mq5,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5 + Q6 + Q7 + Q8 + Q9 + Q10 + Q11;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(1,4) = 2*Q(1,4);
    Q(1,5) = 2*Q(1,5);
    Q(1,6) = 2*Q(1,6);
    Q(2,4) = 2*Q(2,4);
    Q(2,5) = 2*Q(2,5);
    Q(2,6) = 2*Q(2,6);
    Q(2,7) = 2*Q(2,7);
    Q(3,6) = 2*Q(3,6);
    Q(3,7) = 2*Q(3,7);
    Q(3,8) = 2*Q(3,8);
    Q(4,8) = 2*Q(4,8);
    Q(4,9) = 2*Q(4,9);
    Q(5,9) = 2*Q(5,9);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL),length(xSIGNAL)-3) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-3);
    Q(length(xSIGNAL),length(xSIGNAL)-4) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-4);
    Q(length(xSIGNAL),length(xSIGNAL)-5) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-5);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-4) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-4);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-5) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-5);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-6) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-6);
    Q(length(xSIGNAL)-2,length(xSIGNAL)-5) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-5);
    Q(length(xSIGNAL)-2,length(xSIGNAL)-6) = 2*Q(length(xSIGNAL)-2,...
        length(xSIGNAL)-6);
    Q(length(xSIGNAL)-2,length(xSIGNAL)-7) = 2*Q(length(xSIGNAL)-2,...
        length(xSIGNAL)-7);
    Q(length(xSIGNAL)-3,length(xSIGNAL)-7) = 2*Q(length(xSIGNAL)-2,...
        length(xSIGNAL)-7);
    Q(length(xSIGNAL)-3,length(xSIGNAL)-8) = 2*Q(length(xSIGNAL)-2,...
        length(xSIGNAL)-8);
    Q(length(xSIGNAL)-4,length(xSIGNAL)-9) = 2*Q(length(xSIGNAL)-2,...
        length(xSIGNAL)-9);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_sacht_nehab1')==1
    %VALORES DO FILTRO%
    q0 = 0.77412669;
    q1 = 0.11566267;
    q2 = -0.00272602;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_sacht_nehab2')==1
    %VALORES DO FILTRO%
    q0 = 0.65314970;
    q1 = 0.17889730;
    q2 = -0.00547216;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_bspline1') == 1
    fSIGNAL = xSIGNAL;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_sacht_nehab3')==1
    %VALORES DO FILTRO%
    q0 = 0.56528428;
    q1 = 0.21523557;
    q2 = 0.00212228;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
    mq2 = q2*ones(length(xSIGNAL)-2,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q4 = sparse(1:(length(xSIGNAL)-2),3:length(xSIGNAL),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q5 = sparse(3:length(xSIGNAL),1:(length(xSIGNAL)-2),mq2,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3 + Q4 + Q5;
    Q(1,2) = 2*Q(1,2);
    Q(1,3) = 2*Q(1,3);
    Q(2,4) = 2*Q(2,4);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    Q(length(xSIGNAL),length(xSIGNAL)-2) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-2);
    Q(length(xSIGNAL)-1,length(xSIGNAL)-3) = 2*Q(length(xSIGNAL)-1,...
        length(xSIGNAL)-3);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_bspline2')==1
    %VALORES DO FILTRO%
    q0 = 3/4;
    q1 = 1/8;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_bspline3')==1
    %VALORES DO FILTRO%
    q0 = 4/6;
    q1 = 1/6;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_omoms2')==1
    %VALORES DO FILTRO%
    q0 = 86/120;
    q1 = 17/120;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(filter,'ifir_omoms3')==1
    %VALORES DO FILTRO%
    q0 = 0.6190;
    q1 = 0.1905;
    %CRIANDO VETOR COM VALORES DO FILTRO
    mq0 = q0*ones(length(xSIGNAL),1);
    mq1 = q1*ones(length(xSIGNAL)-1,1);
   %CRIANDO MATRIZ SPARSA COM DIAGONAIS DE ACORDO COM VETORES CRIADOS ACIMA
    Q1 = sparse(1:length(xSIGNAL),1:length(xSIGNAL),mq0,...
        length(xSIGNAL),length(xSIGNAL));
    Q2 = sparse(2:length(xSIGNAL),1:(length(xSIGNAL)-1),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q3 = sparse(1:(length(xSIGNAL)-1),2:length(xSIGNAL),mq1,...
        length(xSIGNAL),length(xSIGNAL));
    Q = Q1 + Q2 + Q3;
    Q(1,2) = 2*Q(1,2);
    Q(length(xSIGNAL),length(xSIGNAL)-1) = 2*Q(length(xSIGNAL),...
        length(xSIGNAL)-1);
    %FATORACAO LU E APLICACAO EM SOM
    [L,U] = lu(Q);
    Y = L\xSIGNAL;
    fSIGNAL = U\Y;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%GENERATING FUNCTIONS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if strcmp(generator,'bspline0')==1
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(n*size(xSIGNAL,1),2);
        for i = 1:size(t,2)-2
            a = floor(t(i));
            b = a+1;
            nSIGNAL(i,1) = fSIGNAL(a,1) + fSIGNAL(b,1);
            nSIGNAL(i,2) = fSIGNAL(a,2) + fSIGNAL(b,2);
        end
        nSIGNAL(end)=fSIGNAL(end);
    else 
        nSIGNAL = zeros(n*size(xSIGNAL,1),1);
        for i = 1:size(t,2)-1
            a = floor(t(i));
            b = a+1;
            nSIGNAL(i) = fSIGNAL(a) + fSIGNAL(b);
        end
       nSIGNAL(end)=fSIGNAL(end);
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(generator,'bspline1')
    if size(fSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)-1
            a = floor(t(i));
            b = a+1;
            nSIGNAL(i,1) = (1 - abs(t(i) - a))*fSIGNAL(a,1)...
                + (1 - abs(t(i) -b))*fSIGNAL(b,1);
            nSIGNAL(i,2) = (1 - abs(t(i) - a))*fSIGNAL(a,2)...
                + (1 - abs(t(i) -b))*fSIGNAL(b,2);
        end
    else 
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)-1
            a = floor(t(i));
            b = a+1;
            nSIGNAL(i) = (1 - abs(t(i) - a))*fSIGNAL(a)...
                + (1 - abs(t(i) -b))*fSIGNAL(b);
        end 
    end
    nSIGNAL(end) = fSIGNAL(end);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'bspline2')
    %|r|<1.5
        %(9 + r*(-12 + 4*r))/8
    %|r|<0.5
        %(6 - 8*r*r)/8
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) >= 1 && t(i) < 1.5
                b = a + 1;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8)...
                    + 2*fSIGNAL(b,1)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8)...
                    + 2*fSIGNAL(b,2)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
            elseif t(i) > 1.5 && abs(t(i) - a) == 0.5
                b = a + 1;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,1)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,2)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
            elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1)-0.4)...
                    && abs(t(i) - a) > 0.5
                b = a + 1;
                c = a + 2;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,1)*((6 - 8*abs(t(i) - b)...
                    *abs(t(i) - b))/8) + fSIGNAL(c,1)...
                    *((9 + abs(t(i) - c)*(-12 + 4*abs(t(i) - c)))/8);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,2)*((6 - 8*abs(t(i) - b)...
                    *abs(t(i) - b))/8)...
                    + fSIGNAL(c,2)*((9 + abs(t(i) - c)...
                    *(-12 + 4*abs(t(i) - c)))/8);
            elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1)-0.4) ...
                    && abs(t(i) - a) < 0.5
                b = a - 1;
                c = a + 1;
                nSIGNAL(i,1) = fSIGNAL(b,1)*(((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8))...
                    + fSIGNAL(a,1)*(((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8))...
                    + fSIGNAL(c,1)*(((9 + abs(t(i) - c)...
                    *(-12 + 4*abs(t(i) - c)))/8));
                nSIGNAL(i,2) = fSIGNAL(b,2)*(((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8))...
                    + fSIGNAL(a,2)*(((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8))...
                    + fSIGNAL(c,2)*(((9 + abs(t(i) - c)...
                    *(-12 + 4*abs(t(i) - c)))/8));
            elseif t(i) > (size(xSIGNAL,1)-0.5) && t(i) < size(xSIGNAL,1)
                b = a + 1;
                nSIGNAL(i,1) = 2*fSIGNAL(a,1)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,1)*((6 - 8*abs(t(i) - b)*abs(t(i) - b))/8);
                nSIGNAL(i,2) = 2*fSIGNAL(a,2)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b,2)*((6 - 8*abs(t(i) - b)*abs(t(i) - b))/8);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8)...
                    + fSIGNAL(a,1)*((6 - 8*abs(t(i) - a)*abs(t(i) - a))/8);
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8)...
                    + fSIGNAL(a,2)*((6 - 8*abs(t(i) - a)*abs(t(i) - a))/8);  
            end
        end
    else 
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) >= 1 && t(i) < 1.5
                b = a + 1;
                nSIGNAL(i) = fSIGNAL(a)*((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8)...
                    + 2*fSIGNAL(b)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
            elseif t(i) > 1.5 && abs(t(i) - a) == 0.5
                b = a + 1;
                nSIGNAL(i) = fSIGNAL(a)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8);
            elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1)-0.5)...
                    && abs(t(i) - a) > 0.5
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b)*((6 - 8*abs(t(i) - b)...
                    *abs(t(i) - b))/8)...
                    + fSIGNAL(c)*((9 + abs(t(i) - c)...
                    *(-12 + 4*abs(t(i) - c)))/8);
            elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1)-0.4)...
                    && abs(t(i) - a) < 0.5
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = fSIGNAL(b)*(((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8))...
                    + fSIGNAL(a)*(((6 - 8*abs(t(i) - a)...
                    *abs(t(i) - a))/8))...
                    + fSIGNAL(c)*(((9 + abs(t(i) - c)...
                    *(-12 + 4*abs(t(i) - c)))/8));
            elseif t(i) >= (size(xSIGNAL,1)-0.4) && t(i) < size(xSIGNAL,1)
                b = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(a)*((9 + abs(t(i) - a)...
                    *(-12 + 4*abs(t(i) - a)))/8)...
                    + fSIGNAL(b)*((6 - 8*abs(t(i) - b)*abs(t(i) - b))/8);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*((9 + abs(t(i) - b)...
                    *(-12 + 4*abs(t(i) - b)))/8)...
                    + fSIGNAL(a)*((6 - 8*abs(t(i) - a)*abs(t(i) - a))/8); 
            end
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'bspline3')
    %|r|<1
    %(4 + r*r*(-6 + 3*r))/6;
    %|r|<2
    %(8 + r*(-12 + (6 - r)*r))/6;
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + 2*fSIGNAL(b,1)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + 2*fSIGNAL(b,2)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6);
            elseif t(i) > 1 && t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(b,1)*((4 + abs(t(i)-b)*abs(t(i)-b)...
                    *(-6 + 3*abs(t(i)-b)))/6)...
                    + 2*fSIGNAL(c,1)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(b,2)*((4 + abs(t(i)-b)...
                    *abs(t(i)-b)*(-6 + 3*abs(t(i)-b)))/6)...
                    + 2*fSIGNAL(c,2)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
            elseif t(i) > 1 && abs(t(i) - a) == 0 ...
                    && t(i) <= (size(xSIGNAL,1)-1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i,1) = fSIGNAL(b,1)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(c,1)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
                nSIGNAL(i,2) = fSIGNAL(b,2)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(c,2)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1)-1)
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i,1) = fSIGNAL(b,1)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(c,1)*((4 + abs(t(i)-c)...
                    *abs(t(i)-c)*(-6 + 3*abs(t(i)-c)))/6)...
                    + fSIGNAL(d,1)*((8 + abs(t(i)-d)...
                    *(-12 + (6 - abs(t(i)-d))*abs(t(i)-d)))/6);
                nSIGNAL(i,2) = fSIGNAL(b,2)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(c,2)*((4 + abs(t(i)-c)...
                    *abs(t(i)-c)*(-6 + 3*abs(t(i)-c)))/6)...
                    + fSIGNAL(d,2)*((8 + abs(t(i)-d)...
                    *(-12 + (6 - abs(t(i)-d))*abs(t(i)-d)))/6);
            elseif t(i) > (size(xSIGNAL,1)-1) && t(i) < size(xSIGNAL,1)
                b = a + 1;
                c = a - 1;
                nSIGNAL(i,1) = 2*fSIGNAL(c,1)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6)...
                    + fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(b,1)*((4 + abs(t(i)-b)...
                    *abs(t(i)-b)*(-6 + 3*abs(t(i)-b)))/6);
                nSIGNAL(i,2) = 2*fSIGNAL(c,2)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6)...
                    + fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(b,2)*((4 + abs(t(i)-b)...
                    *abs(t(i)-b)*(-6 + 3*abs(t(i)-b)))/6);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,1)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6);
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a,2)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6);
            end
        end
    else 
        %|r|<1
        %(4 + r*r*(-6 + 3*r))/6;
        %|r|<2
        %(8 + r*(-12 + (6 - r)*r))/6;
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                nSIGNAL(i) = fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + 2*fSIGNAL(b)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6);
            elseif t(i) > 1 && t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(b)*((4 + abs(t(i)-b)...
                    *abs(t(i)-b)*(-6 + 3*abs(t(i)-b)))/6)...
                    + 2*fSIGNAL(c)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
            elseif t(i) > 1 && abs(t(i) - a) == 0 ...
                    && t(i) <= (size(xSIGNAL,1)-1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = fSIGNAL(b)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6)...
                    + fSIGNAL(c)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6);
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1)-1)
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6)...
                    + fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6) ...
                    + fSIGNAL(c)*((4 + abs(t(i)-c)*abs(t(i)-c)...
                    *(-6 + 3*abs(t(i)-c)))/6) ...
                    + fSIGNAL(d)*((8 + abs(t(i)-d)*...
                    (-12 + (6 - abs(t(i)-d))*abs(t(i)-d)))/6);
            elseif t(i) > (size(xSIGNAL,1)-1) && t(i) < size(xSIGNAL,1)
                b = a + 1;
                c = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(c)*((8 + abs(t(i)-c)...
                    *(-12 + (6 - abs(t(i)-c))*abs(t(i)-c)))/6) ...
                    + fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6) ...
                    + fSIGNAL(b)*((4 + abs(t(i)-b)...
                    *abs(t(i)-b)*(-6 + 3*abs(t(i)-b)))/6);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*((8 + abs(t(i)-b)...
                    *(-12 + (6 - abs(t(i)-b))*abs(t(i)-b)))/6) ...
                    + fSIGNAL(a)*((4 + abs(t(i)-a)...
                    *abs(t(i)-a)*(-6 + 3*abs(t(i)-a)))/6);
            end
        end
        
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'omoms2')
    %r = fabsf(r);
     %           if (r < .5f) return (86.f-120.f*r*r)/120.f;
      %          else if (r == .5f) return 59.f/120.f; // discontinuity!
       %         else if (r < 1.5f) return (137.f+r*(-180.f+60*r))/120.f;
        %        else if (r == 1.5f) return 1.f/120.f; // discontinuity!
         %       else return 0.f;
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)
           
        end 
    else 
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) < 1.5
                b = a + 1;
                nSIGNAL(i) = fSIGNAL(a)*((86-120*abs(t(i)-a)...
                    *abs(t(i)-a))/120) ...
                    + 2*fSIGNAL(b)*((137+abs(t(i)-b)...
                    *(-180+60*abs(t(i)-b)))/120);
            elseif t(i) == 1.5
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*(59/120) + fSIGNAL(b)*(59/120) ...
                    + 2*fSIGNAL(c)*(1/120);
            elseif t(i) > 1.5 && t(i) < size(xSIGNAL,1) - 0.5 ...
                    && abs(t(i) - a) > 0.5
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*((137+abs(t(i)-a)...
                    *(-180+60*abs(t(i)-a)))/120) ...
                    + fSIGNAL(b)*((86-120*abs(t(i)-b)...
                    *abs(t(i)-b))/120) + ...
                    + fSIGNAL(c)*((137+abs(t(i)-c)...
                    *(-180+60*abs(t(i)-c)))/120);
            elseif t(i) > 1.5 && t(i) < size(xSIGNAL,1) - 0.5 ...
                    && abs(t(i) - a) < 0.5
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = fSIGNAL(b)*((137+abs(t(i)-b)...
                    *(-180+60*abs(t(i)-b)))/120) ...
                    + fSIGNAL(a)*((86-120*abs(t(i)-a)*abs(t(i)-a))/120) ...
                    + fSIGNAL(c)*((137+abs(t(i)-c)...
                    *(-180+60*abs(t(i)-c)))/120);
            elseif t(i) > 1.5 && t(i) < size(xSIGNAL,1) - 0.5 ...
                    && abs(t(i) - a) == 0.5
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*(1/120) + fSIGNAL(a)*(59/120) ...
                    + fSIGNAL(c)*(59/120) + fSIGNAL(d)*(1/120);
            elseif t(i) == size(xSIGNAL,1) - 0.5
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*(1/120) + fSIGNAL(a)*(59/120) ...
                    + fSIGNAL(c)*(59/120);
            elseif t(i) > size(xSIGNAL,1) - 0.5 && t(i) < size(xSIGNAL,1)
                b = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(a)*((137+abs(t(i)-a)...
                    *(-180+60*abs(t(i)-a)))/120) ...
                    + fSIGNAL(b)*((86-120*abs(t(i)-b)*abs(t(i)-b))/120);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*((137+abs(t(i)-b)...
                    *(-180+60*abs(t(i)-b)))/120) ...
                    + fSIGNAL(a)*((86-120*abs(t(i)-a)*abs(t(i)-a))/120);
            end
        end 
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'omoms3')
    %|r| < 2
    %(58+r*(-85+(42-7*r)*r))/42
    %|r| < 1
    %(26+r*(3+r*(-42+21*r)))/42
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + 2*fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + 2*fSIGNAL(b,2)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42);
            elseif t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i,1) = fSIGNAL(a,1)*((26+abs(t(i)-a)...
                    *(3+abs(t(i)-a)*(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(b,1)*((26+abs(t(i)-b)*(3+abs(t(i)-b)...
                    *(-42+21*abs(t(i)-b))))/42) ...
                    + 2*fSIGNAL(c,1)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
                nSIGNAL(i,2) = fSIGNAL(a,2)*((26+abs(t(i)-a)...
                    *(3+abs(t(i)-a)*(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(b,2)*((26+abs(t(i)-b)*(3+abs(t(i)-b)...
                    *(-42+21*abs(t(i)-b))))/42) ...
                    + 2*fSIGNAL(c,2)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
            elseif t(i) >= 2 && t(i) <= (size(xSIGNAL,1)-1) ...
                    && abs(t(i) - a) == 0
                b = a - 1;
                c = a + 1;
                nSIGNAL(i,1) = fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,1)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,1)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
                nSIGNAL(i,2) = fSIGNAL(b,2)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,2)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,2)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1)-1) ...
                    && abs(t(i) - a) > 0
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i,1) = fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,1)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,1)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42) ...
                    + fSIGNAL(d,1)*((58+abs(t(i)-d)...
                    *(-85+(42-7*abs(t(i)-d))*abs(t(i)-d)))/42);
                nSIGNAL(i,2) = fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,2)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,2)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42) ...
                    + fSIGNAL(d,2)*((58+abs(t(i)-d)...
                    *(-85+(42-7*abs(t(i)-d))*abs(t(i)-d)))/42);
            elseif t(i) > (size(xSIGNAL,1)-1) && t(i) < size(xSIGNAL,1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,1)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,1)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42);
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,2)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c,2)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,1)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42);
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a,2)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42);
            end
        end   
    else 
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                nSIGNAL(i) = fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + 2*fSIGNAL(b)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42);
            elseif t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(b)*((26+abs(t(i)-b)*(3+abs(t(i)-b)...
                    *(-42+21*abs(t(i)-b))))/42) ...
                    + 2*fSIGNAL(c)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
            elseif t(i) >= 2 && t(i) <= (size(xSIGNAL,1)-1) ...
                    && abs(t(i) - a) == 0
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = fSIGNAL(b)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c)*((58+abs(t(i)-c)...
                    *(-85+(42-7*abs(t(i)-c))*abs(t(i)-c)))/42);
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1)-1) ...
                    && abs(t(i) - a) > 0
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42) ...
                    + fSIGNAL(d)*((58+abs(t(i)-d)...
                    *(-85+(42-7*abs(t(i)-d))*abs(t(i)-d)))/42);
            elseif t(i) > (size(xSIGNAL,1)-1) && t(i) < size(xSIGNAL,1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42) ...
                    + fSIGNAL(c)*((26+abs(t(i)-c)*(3+abs(t(i)-c)...
                    *(-42+21*abs(t(i)-c))))/42);
            elseif t(i) == size(xSIGNAL,1)
                b = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*((58+abs(t(i)-b)...
                    *(-85+(42-7*abs(t(i)-b))*abs(t(i)-b)))/42) ...
                    + fSIGNAL(a)*((26+abs(t(i)-a)*(3+abs(t(i)-a)...
                    *(-42+21*abs(t(i)-a))))/42);
            end
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'sacht_nehab1')
    %r = fabsf(r);
     %           if (r < 1.f) return 0.89538176f - 0.79076352f*r;
       %         else if (r==1.f) return 0.05230912f;
        %        else return 0.f;
        if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
            for i = 1:size(t,2)
                a = floor(t(i));
                if t(i) == 1
                    b = a + 1;
                    nSIGNAL(i,1) = fSIGNAL(a,1)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b,1)*0.05230912;
                    nSIGNAL(i,2) = fSIGNAL(a,2)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b,2)*0.05230912;
                elseif t(i) > 1 && t(i) < size(xSIGNAL,1) ...
                        && abs(t(i) - a) ~= 0
                    b = a + 1;
                    nSIGNAL(i,1) = fSIGNAL(a,1)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(b,1)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-b));
                    nSIGNAL(i,2) = fSIGNAL(a,2)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(b,2)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-b));
                elseif t(i) > 1 && t(i) < size(xSIGNAL,1) ...
                        && abs(t(i) - a) == 0
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i,1) = fSIGNAL(b,1)*0.05230912 ...
                        + fSIGNAL(a,1)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(c,1)*0.05230912;
                    nSIGNAL(i,2) = fSIGNAL(b,2)*0.05230912 ...
                        + fSIGNAL(a,2)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(c,2)*0.05230912;
                elseif t(i) == size(xSIGNAL,1)
                    b = a - 1;
                    nSIGNAL(i,1) = 2*fSIGNAL(b,1)*0.05230912 ...
                        + fSIGNAL(a,1)*(0.89538176 - 0.79076352...
                        *abs(t(i)-a));
                    nSIGNAL(i,2) = 2*fSIGNAL(b,2)*0.05230912 ...
                        + fSIGNAL(a,2)*(0.89538176 - 0.79076352...
                        *abs(t(i)-a));
                end
            end
        else
            nSIGNAL = zeros(size(t,2),1);
            for i = 1:size(t,2)
                a = floor(t(i));
                if t(i) == 1
                    b = a + 1;
                    nSIGNAL(i) = fSIGNAL(a)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b)*0.05230912;
                elseif t(i) > 1 && t(i) < size(xSIGNAL,1) ...
                        && abs(t(i) - a) ~= 0
                    b = a + 1;
                    nSIGNAL(i) = fSIGNAL(a)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(b)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-b));
                elseif t(i) > 1 && t(i) < size(xSIGNAL,1) ...
                        && abs(t(i) - a) == 0
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i) = fSIGNAL(b,1)*0.05230912 ...
                        + fSIGNAL(a)*(0.89538176 ...
                        - 0.79076352*abs(t(i)-a)) ...
                        + fSIGNAL(c)*0.05230912;
                elseif t(i) == size(xSIGNAL,1)
                    b = a - 1;
                    nSIGNAL(i) = 2*fSIGNAL(b)*0.05230912 ...
                        + fSIGNAL(a)*(0.89538176 - 0.79076352*abs(t(i)-a));
                end
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'sacht_nehab2')
   %r = fabsf(r);
    %            if (r < 0.5f)
     %               return 0.66118661f - 0.75627421f*r*r;
      %          else if (r==0.5f)
       %             return 0.49205903f;
        %        else if (r < 1.5f)
         %           return 1.04366188f - 1.25239228f*r + 0.37813711f*r*r;
          %      else if (r==1.5f)
           %         return 0.00794097f;
            %    else return 0.f;
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
            for i = 1:size(t,2)
                a = floor(t(i));
                if t(i) < 1.5
                    b = a + 1;
                    nSIGNAL(i,1) = fSIGNAL(a,1)*(0.66118661 ...
                        - 0.75627421*abs(t(i)-a)*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-b) ...
                        + 0.37813711*abs(t(i)-b)*abs(t(i)-b));
                    nSIGNAL(i,2) = fSIGNAL(a,2)*(0.66118661 ...
                        - 0.75627421*abs(t(i)-a)*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-b) ...
                        + 0.37813711*abs(t(i)-b)*abs(t(i)-b));
                elseif t(i) == 1.5
                    b = a + 1;
                    c = a + 2;
                    nSIGNAL(i,1) = fSIGNAL(a,1)*0.49205903 ...
                        + fSIGNAL(b,1)*0.49205903 ...
                        + 2*fSIGNAL(c,1)*0.00794097;
                    nSIGNAL(i,2) = fSIGNAL(a,2)*0.49205903 ...
                        + fSIGNAL(b,2)*0.49205903 ...
                        + 2*fSIGNAL(c,2)*0.00794097;
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) > 0.5
                    b = a + 1;
                    c = a + 2;
                    nSIGNAL(i,1) = fSIGNAL(a,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-a) ...
                        + 0.37813711*abs(t(i)-a)*abs(t(i)-a)) ...
                        + fSIGNAL(b,1)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(c,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                    nSIGNAL(i,2) = fSIGNAL(a,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-a) ...
                        + 0.37813711*abs(t(i)-a)*abs(t(i)-a)) ...
                        + fSIGNAL(b,2)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(c,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) < 0.5
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i,1) = fSIGNAL(b,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a,1)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(c,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                    nSIGNAL(i,2) = fSIGNAL(b,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a,2)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(c,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) == 0.5
                    b = a - 1;
                    c = a + 1;
                    d = a + 2;
                    nSIGNAL(i,1) = fSIGNAL(b,1)*0.00794097 ...
                        + fSIGNAL(a,1)*0.49205903 ...
                        + fSIGNAL(c,1)*0.49205903 ...
                        + fSIGNAL(d,1)*0.00794097;
                    nSIGNAL(i,2) = fSIGNAL(b,2)*0.00794097 ...
                        + fSIGNAL(a,2)*0.49205903 ...
                        + fSIGNAL(c,2)*0.49205903 ...
                        + fSIGNAL(d,2)*0.00794097;
                elseif t(i) == (size(xSIGNAL,1) - 0.5)
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i,1) = 2*fSIGNAL(b,1)*0.00794097 ...
                        + fSIGNAL(a,1)*0.49205903 ...
                        + fSIGNAL(c,1)*0.49205903;
                    nSIGNAL(i,2) = 2*fSIGNAL(b,2)*0.00794097 ...
                        + fSIGNAL(a,2)*0.49205903 ...
                        + fSIGNAL(c,2)*0.49205903;
                elseif t(i) > (size(xSIGNAL,1) - 0.5) ...
                        && t(i) < size(xSIGNAL,1)
                    b = a + 1;
                    nSIGNAL(i,1) = 2*fSIGNAL(a,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - a) ...
                        + 0.37813711*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(b,1)*(0.66118661 - 0.75627421...
                        *abs(t(i) - b)*abs(t(i) - b));
                    nSIGNAL(i,2) = 2*fSIGNAL(a,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - a) ...
                        + 0.37813711*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(b,2)*(0.66118661 - 0.75627421...
                        *abs(t(i) - b)*abs(t(i) - b));
                elseif t(i) == size(xSIGNAL,1)
                    b = a - 1;
                    nSIGNAL(i,1) = 2*fSIGNAL(b,1)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a,1)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a));
                    nSIGNAL(i,2) = 2*fSIGNAL(b,2)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a,2)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a));
                end
            end
    else
            nSIGNAL = zeros(size(t,2),1);
            for i = 1:size(t,2)
                a = floor(t(i));
                if t(i) < 1.5
                    b = a + 1;
                    nSIGNAL(i) = fSIGNAL(a)*(0.66118661 ...
                        - 0.75627421*abs(t(i)-a)*abs(t(i)-a)) ...
                        + 2*fSIGNAL(b)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-b) ...
                        + 0.37813711*abs(t(i)-b)*abs(t(i)-b));
                elseif t(i) == 1.5
                    b = a + 1;
                    c = a + 2;
                    nSIGNAL(i) = fSIGNAL(a)*0.49205903 ...
                        + fSIGNAL(b)*0.49205903 ...
                        + 2*fSIGNAL(c)*0.00794097;
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) > 0.5
                    b = a + 1;
                    c = a + 2;
                    nSIGNAL(i) = fSIGNAL(a)*(1.04366188 ...
                        - 1.25239228*abs(t(i)-a) ...
                        + 0.37813711*abs(t(i)-a)*abs(t(i)-a)) ...
                        + fSIGNAL(b)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(c)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) < 0.5
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i) = fSIGNAL(b)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(c)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - c) ...
                        + 0.37813711*abs(t(i) - c)*abs(t(i) - c));
                elseif t(i) > 1.5 && t(i) < (size(xSIGNAL,1) - 0.5) ...
                        && abs(t(i)-a) == 0.5
                    b = a - 1;
                    c = a + 1;
                    d = a + 2;
                    nSIGNAL(i) = fSIGNAL(b)*0.00794097 ...
                        + fSIGNAL(a)*0.49205903 ...
                        + fSIGNAL(c)*0.49205903 ...
                        + fSIGNAL(d)*0.00794097;
                elseif t(i) == (size(xSIGNAL,1) - 0.5)
                    b = a - 1;
                    c = a + 1;
                    nSIGNAL(i) = 2*fSIGNAL(b)*0.00794097 ...
                        + fSIGNAL(a)*0.49205903 ...
                        + fSIGNAL(c)*0.49205903;
                elseif t(i) > (size(xSIGNAL,1) - 0.5) ...
                        && t(i) < size(xSIGNAL,1)
                    b = a + 1;
                    nSIGNAL(i) = 2*fSIGNAL(a)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - a) ...
                        + 0.37813711*abs(t(i) - a)*abs(t(i) - a)) ...
                        + fSIGNAL(b)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - b)*abs(t(i) - b));
                elseif t(i) == size(xSIGNAL,1)
                    b = a - 1;
                    nSIGNAL(i) = 2*fSIGNAL(b)*(1.04366188 ...
                        - 1.25239228*abs(t(i) - b) ...
                        + 0.37813711*abs(t(i) - b)*abs(t(i) - b)) ...
                        + fSIGNAL(a)*(0.66118661 ...
                        - 0.75627421*abs(t(i) - a)*abs(t(i) - a));
                end
            end
            
   end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
elseif strcmp(generator,'sacht_nehab3')
%r = fabsf(r);
 %               if (r==0.f)
  %                  return 0.56259136f;
   %             else if (r < 1.f)
    %                return 0.56259136f + 0.04465421f*r - 0.70001154f*r*r 
     %                  + 0.30938685f*r*r*r;
      %           else if (r==1.f) 
       %              return 0.21773426f;
        %         else if (r < 2.f)
         %            return 1.17739188f - 1.50921205f*r + 0.64059253f*r*r
          %             - 0.08992473f*r*r*r;
           %      else if (r==2.f) 
            %          return 0.00097005f;
             %     else return 0.f;
    if size(xSIGNAL,2) == 2
        nSIGNAL = zeros(size(t,2),2);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                c = a + 2;
                nSIGNAL(i,1) = fSIGNAL(a,1)*0.56259136 ...
                    + 2*fSIGNAL(b,1)*0.21773426 ...
                    + 2*fSIGNAL(c,1)*0.00097005;
                nSIGNAL(i,2) = fSIGNAL(a,2)*0.56259136 ...
                    + 2*fSIGNAL(b,2)*0.21773426 ...
                    + 2*fSIGNAL(c,2)*0.00097005;
            elseif t(i) > 1 && t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i,1) = fSIGNAL(a,1)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(b,1)*(0.56259136 + ...
                    0.04465421*abs(t(i) - b) ...
                    - 0.70001154*abs(t(i) - b)*abs(t(i) - b) ...
                    + 0.30938685*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + 2*fSIGNAL(c,1)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)...
                    *abs(t(i) - c)*abs(t(i) - c));
                nSIGNAL(i,2) = fSIGNAL(a,2)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(b,2)*(0.56259136 + ...
                    0.04465421*abs(t(i) - b) ...
                    - 0.70001154*abs(t(i) - b)*abs(t(i) - b) ...
                    + 0.30938685*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + 2*fSIGNAL(c,2)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c));
            elseif t(i) == 2
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i,1) = fSIGNAL(b,1)*0.21773426 ...
                    + fSIGNAL(a,1)*0.56259136 ...
                    + fSIGNAL(c,1)*0.21773426 ...
                    + 2*fSIGNAL(d,1)*0.00097005;
                nSIGNAL(i,2) = fSIGNAL(b,2)*0.21773426 ...
                    + fSIGNAL(a,2)*0.56259136 ...
                    + fSIGNAL(c,2)*0.21773426 ...
                    + 2*fSIGNAL(d,2)*0.00097005;
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1) - 1) ...
                    && abs(t(i) - a) ~= 0
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i,1) = fSIGNAL(b,1)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a,1)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c,1)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - c) ...
                    - 0.70001154*abs(t(i) - c)*abs(t(i) - c) ...
                    + 0.30938685*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c)) + fSIGNAL(d,1)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - d) ...
                    + 0.64059253*abs(t(i) - d)*abs(t(i) - d) ...
                    - 0.08992473*abs(t(i) - d)*abs(t(i) - d)...
                    *abs(t(i) - d));
                nSIGNAL(i,2) = fSIGNAL(b,2)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a,2)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c,2)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - c) ...
                    - 0.70001154*abs(t(i) - c)*abs(t(i) - c) ...
                    + 0.30938685*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c)) + fSIGNAL(d,2)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - d) ...
                    + 0.64059253*abs(t(i) - d)*abs(t(i) - d) ...
                    - 0.08992473*abs(t(i) - d)*abs(t(i) - d)...
                    *abs(t(i) - d));
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1) - 1) ...
                    && abs(t(i) - a) == 0
                b = a - 2;
                c = a - 1;
                d = a + 1;
                e = a + 2;
                nSIGNAL(i,1) = fSIGNAL(b,1)*0.00097005 ...
                    + fSIGNAL(c,1)*0.21773426 ...
                    + fSIGNAL(a,1)*0.56259136 ...
                    + fSIGNAL(d,1)*0.21773426 ...
                    + fSIGNAL(e,1)*0.00097005;
                nSIGNAL(i,2) = fSIGNAL(b,2)*0.00097005 ...
                    + fSIGNAL(c,2)*0.21773426 ...
                    + fSIGNAL(a,2)*0.56259136 ...
                    + fSIGNAL(d,2)*0.21773426 ...
                    + fSIGNAL(e,2)*0.00097005;
            elseif t(i) == (size(xSIGNAL,1) - 1)
                b = a - 2;
                c = a - 1;
                d = a + 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*0.00097005 ...
                    + fSIGNAL(c,1)*0.21773426 ...
                    + fSIGNAL(a,1)*0.56259136 ...
                    + fSIGNAL(d,1)*0.21773426;
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*0.00097005 ...
                    + fSIGNAL(c,2)*0.21773426 ...
                    + fSIGNAL(a,2)*0.56259136 ...
                    + fSIGNAL(d,2)*0.21773426;
            elseif t(i) > (size(xSIGNAL,1) - 1) && t(i) < size(xSIGNAL,1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a,1)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c,1)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c));
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a,2)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c,2)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c));
            elseif t(i) == size(xSIGNAL,1)
                b = a - 2;
                c = a - 1;
                nSIGNAL(i,1) = 2*fSIGNAL(b,1)*0.00097005 ...
                    + 2*fSIGNAL(c,1)*0.21773426...
                    + fSIGNAL(a,1)*0.56259136;
                nSIGNAL(i,2) = 2*fSIGNAL(b,2)*0.00097005 ...
                    + 2*fSIGNAL(c,2)*0.21773426...
                    + fSIGNAL(a,2)*0.56259136;
            end
        end
    else
        nSIGNAL = zeros(size(t,2),1);
        for i = 1:size(t,2)
            a = floor(t(i));
            if t(i) == 1
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*0.56259136 ...
                    + 2*fSIGNAL(b)*0.21773426 ...
                    + 2*fSIGNAL(c)*0.00097005;
            elseif t(i) > 1 && t(i) < 2
                b = a + 1;
                c = a + 2;
                nSIGNAL(i) = fSIGNAL(a)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(b)*(0.56259136 + ...
                    0.04465421*abs(t(i) - b) ...
                    - 0.70001154*abs(t(i) - b)*abs(t(i) - b) ...
                    + 0.30938685*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + 2*fSIGNAL(c)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c));
            elseif t(i) == 2
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*0.21773426 ...
                    + fSIGNAL(a)*0.56259136 ...
                    + fSIGNAL(c)*0.21773426 ...
                    + 2*fSIGNAL(d)*0.00097005;
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1) - 1) ...
                    && abs(t(i) - a) ~= 0
                b = a - 1;
                c = a + 1;
                d = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - c) ...
                    - 0.70001154*abs(t(i) - c)*abs(t(i) - c) ...
                    + 0.30938685*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c)) + fSIGNAL(d)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - d) ...
                    + 0.64059253*abs(t(i) - d)*abs(t(i) - d) ...
                    - 0.08992473*abs(t(i) - d)*abs(t(i) - d)...
                    *abs(t(i) - d));
            elseif t(i) > 2 && t(i) < (size(xSIGNAL,1) - 1) ...
                    && abs(t(i) - a) == 0
                b = a - 2;
                c = a - 1;
                d = a + 1;
                e = a + 2;
                nSIGNAL(i) = fSIGNAL(b)*0.00097005 ...
                    + fSIGNAL(c)*0.21773426 ...
                    + fSIGNAL(a)*0.56259136 ...
                    + fSIGNAL(d)*0.21773426 ...
                    + fSIGNAL(e)*0.00097005;
            elseif t(i) == (size(xSIGNAL,1) - 1)
                b = a - 2;
                c = a - 1;
                d = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*0.00097005 ...
                    + fSIGNAL(c)*0.21773426 ...
                    + fSIGNAL(a)*0.56259136 ...
                    + fSIGNAL(d)*0.21773426;
            elseif t(i) > (size(xSIGNAL,1) - 1) && t(i) < size(xSIGNAL,1)
                b = a - 1;
                c = a + 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - b) ...
                    + 0.64059253*abs(t(i) - b)*abs(t(i) - b) ...
                    - 0.08992473*abs(t(i) - b)*abs(t(i) - b)...
                    *abs(t(i) - b)) + fSIGNAL(a)*(0.56259136 ...
                    + 0.04465421*abs(t(i) - a) ...
                    - 0.70001154*abs(t(i) - a)*abs(t(i) - a) ...
                    + 0.30938685*abs(t(i) - a)*abs(t(i) - a)...
                    *abs(t(i) - a)) + fSIGNAL(c)*(1.17739188 ...
                    - 1.50921205*abs(t(i) - c) ...
                    + 0.64059253*abs(t(i) - c)*abs(t(i) - c) ...
                    - 0.08992473*abs(t(i) - c)*abs(t(i) - c)...
                    *abs(t(i) - c));
            elseif t(i) == size(xSIGNAL,1)
                b = a - 2;
                c = a - 1;
                nSIGNAL(i) = 2*fSIGNAL(b)*0.00097005 ...
                    + 2*fSIGNAL(c)*0.21773426...
                    + fSIGNAL(a)*0.56259136;
            end
        end
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
end
end
